%esercizio2 (Prof. Carla Braitenberg)

%conduttivita' termica per stratigrafia e dipende da Temperatura
% 5 strati in input e geoterma
clear all
kw=0.6;% %W/mK  CONDUCTIVITY water
%strato1 sand
d(1,1)=0; d(1,2)=1.300;% depth
phi(1)=0.35; % porosity 
km(1)=1.79; %W/mK  CONDUCTIVITY matrix
% strato 2 Siltstone
d(2,1)=1.3; d(2,2)=3.500;% depth
phi(2)=0.30; % porosity 
km(2)=1.58; %W/mK  CONDUCTIVITY matrix
b(2)=0.379; % decay factor porosity km^-1
% strato 3 Clay
d(3,1)=3.5; d(3,2)=4.800;% depth
phi(3)=0.25; % porosity 

km(3)=1.88; %W/mK  CONDUCTIVITY matrix
b(3)=0.293; % decay factor porosity km^-1
% strato 4 Marl
d(4,1)=4.8; d(4,2)=7.2;% depth
phi(4)=0.15; % porosity 
km(4)=1.68; %W/mK  CONDUCTIVITY matrix
b(4)=0.298; % decay factor porosity km^-1
% strato 5 Limestone 
d(5,1)=7.2; d(5,2)=10.;% depth
phi(5)=0.40; % porosity 
km(5)=2.37; %W/mK  CONDUCTIVITY matrix
b(5)=0.396; % decay factor porosity km^-1
% calcolo isoterma
%a z=0 dT/dz=30C/km decrescente a 21C/km a 10km
T0=0; % temperatura a superficie z=0
n=50; % numero passo
dz=12/n;
T(1)=0;
zT(1)=0;
for i=2:n
    zT(i)=zT(1)+(i-1)*dz;
    dT_dz(i)=30+(21-30)/10*(i-1)*dz;
    T(i)=dT_dz(i)*dz+T(i-1);
end
   figure
   subplot(1,2,1);
   plot(zT,T)
   xlabel('z (km)'); ylabel('T (C)');
title(['Geothermal curve'])

%figure
subplot(1,2,2);
hold on
nz=10;
for i=1:5
    z(i,:)=linspace(d(i,1),d(i,2),nz);
    zstrato=z(i,:); % zstrato e' riga
    Tint=interp1(zT,T,zstrato);
    for j=1:nz
    phiz(j)= phi(i)*exp(-b(i)*zstrato(j)) ; % porosita' in funzione depth
% kmT(i,j): correzione di km per la temperatura(j)
    kmT(i,j)=1.8418+(km(i)-1.8418)*((0.002732*Tint(j)+0.7463)^-1-0.2485);
% kwT(i,j): correzione di kw per la temperatura(j)
    if Tint(j) <= 137
    kwT(i,j)=0.5648+1.878*0.001*Tint(j);
    else
    kwT(i,j)=0.6020+1.309*0.001*Tint(j)-5.140*10^-6*Tint(j)^2;
    end
 kT(i,j)=kmT(i,j)^(1-phiz(j))*kwT(i,j)^phiz(j); 
    end    % end calculating parameters in function of depth

kmedio(i)=mean(kT(i,:));
plot(z(i,:),kT(i,:))
xlabel('z (km)'); ylabel('k(T) (W/mK)');
    
end
% Conduttivita' termica media come media armonic
 perc=(d(:,2)/10);
 prod=(1./kmedio').*perc
 kmed=sum(prod)
 title(['conductivity Temp.-corrected.kmed= ' num2str(kmed)])
% 
