%esercizio3 (Prof. Carla Braitenberg)
%conduttivita' reticolare e radiativa in funzione della temperatura
% pressione e geoterma data da tabella
% roccia: olivina contenente il 90% di forsterite.
clear all
zT=load('Geoterma_Es3.txt');
zP=load('Pressione_profondita.txt');
nT=length(zT(:,1)); nP=length(zP(:,1));
figure
subplot(2,2,1)
plot(zT(:,1),zT(:,2))
xlabel('z (km)'); ylabel('T (C)');
subplot(2,2,2)
plot(zP(:,1),zP(:,2))
xlabel('z (km)'); ylabel('P (GPa)');
%depth 
for i=1:nT
    % define pressure for given Temperature value
    P=interp1(zP(:,1),zP(:,2),zT(i,1));

    % km lattice conductivity
    chi=0.9   %mole fraction of fosterite for the olivine rock
    n=0.49
    lam_m=3.09-1.17*chi    %3.09 conduct of olivine, 1.17 of fosterite
    Kt=128   % GPa
    Ktgrd=4.2   %pressure gradient of Kt
    TKelv=zT(i,2)+273.15;
km(i)=lam_m * (298/TKelv)^n * (1 + Ktgrd/Kt*P );
% kr radiative conductivity
% erf Error function.
%     Y = erf(X) is the error function for each element of X.  X must be
%     real. The error function is defined as:
%  
%       erf(x) = 2/sqrt(pi) * integral from 0 to x of exp(-t^2) dt.
lam_r= 0.345; % W/m/K  maximum radiative conductivity
Tr= 762;  %K     temperature at 0.5 lam_r
om= 256; % K  scaling factor
kr(i)=0.5*lam_r*(1+ erf((TKelv-Tr)/om) );

end

subplot(2,2,3)
plot(zT(:,2),km,zT(:,2),km+kr)   %
xlabel('T (C)'); ylabel('klattice (W/mK)');
subplot(2,2,4)
plot(zT(:,2),kr)   %
xlabel('T (C)'); ylabel('kradiative (W/mK)');

