%calore radiogenico presente e al tempo T per un granito
% Esercizio 4 (Prof. Carla Braitenberg)
% A=rho*(sum(Pi * Asi * ci)
%percentage of radiogenic element
% c(t)= c exp(t*ln2/tau) concentration of an isotope at time t 
% tau: ln2/lam= half life with lam decay costant

% valori da letteratura su produzione di calore 
clear all
A_U238= 96.7;   % Uranium 238 (microWatt/kg)
A_Th232= 26.3;   % Thorium 232 (microWatt/kg)
A_K40= 3.5E-03;   % Uranium 238 (microWatt/kg)
tau_U238=4.47E09;
tau_U235=0.7E09;
tau_Th232=14E09;
tau_K40=25E09;
P_U238=0.993; P_U235=0.0071; P_Th232=1; P_k40=0.00012;
rho=2700; % densita' granito (kg/m3);
t=0:1E06:4E09;
c_U238=4.3*1E-06; % Abundance Uranium
c_Th232=12.2*1E-06; % Abundance Thorium
c_K40=5.1*1E-02; % Abundance Uranium

A_El= [A_U238, A_Th232, A_K40];

tau=[tau_U238, tau_Th232,tau_K40];
c(1:3)=[c_U238, c_Th232,c_K40];
% A for two instances of time
t1=1.5E09;

ct1= c.*exp(t1*log(2)./tau);
ct0=c;
A0=rho*ct0*A_El';
A1=rho*ct1*A_El';
disp(['A al tempo attuale: ',num2str(A0),' microW/m3; A al tempo ',num2str(t1/1E09),' Gyr : ',num2str(A1),' microW/m3'])
% A_Element in function of time
for i=1:length(t)
    for j=1:3
  ct(j,i)= c(j)*exp(t(i)*log(2)/tau(j));   % abundance as function of time
  A_element(j,i)=rho*ct(j,i)*A_El(j);
  Asum(i)=sum(A_element(:,i));
    end
end

figure
plot(t,A_element(1:3,:),t,Asum)
 xlabel('time (yr)'); ylabel('A (microwatts/m3)');
title('Radiogenic Heatproduction')
legend('A U238', 'A Th232', 'A K40', 'Asummed')




